//
//  CPCLPrinterVC.m
//  PrinterDemo
//
//  Created by Apple Mac mini intel on 2024/5/25.
//

#import "CPCLPrinterVC.h"
#import "XSDKPrinter.h"
#import "UIView+Toast.h"
@interface CPCLPrinterVC ()<XBLEManagerDelegate, XWIFIManagerDelegate>
@property (strong, nonatomic) XBLEManager *bleManager;
@property (strong, nonatomic) XWIFIManager *wifiManager;
@property (weak, nonatomic) IBOutlet UISlider *speedSlider;
@property (weak, nonatomic) IBOutlet UISegmentedControl *alignSeg;
@property (weak, nonatomic) IBOutlet UILabel *speedLabel;

@end

@implementation CPCLPrinterVC

- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = @"CPCL PRINT";
    _bleManager = [XBLEManager sharedInstance];
    _bleManager.delegate = self;
    _wifiManager = [XWIFIManager sharedInstance];
    _wifiManager.delegate = self;
}


- (IBAction)printTextAction:(id)sender {
    XCPCLCommand *command = [[XCPCLCommand alloc] init];
    [command initLabelWithHeight:240 count:1];
    [command addTextAtX:50 y:0 rotation:CPCLRotation0 font:CPCLFont0 content:@"CPCLFont0"];
    [command addTextAtX:200 y:0 rotation:CPCLRotation0 font:CPCLFont1 content:@"CPCLFont1"];
    [command addTextAtX:50 y:40 rotation:CPCLRotation0 font:CPCLFont2 content:@"CPCLFont2"];
    [command addTextAtX:200 y:40 rotation:CPCLRotation0 font:CPCLFont3 content:@"CPCLFont3"];
    [command addTextAtX:50 y:80 rotation:CPCLRotation0 font:CPCLFont4 content:@"CPCLFont4"];
    [command addTextAtX:200 y:80 rotation:CPCLRotation0 font:CPCLFont5 content:@"CPCLFont5"];
    [command addTextAtX:50 y:120 rotation:CPCLRotation0 font:CPCLFont6 content:@"CPCLFont6"];
    [command addTextAtX:200 y:120 rotation:CPCLRotation0 font:CPCLFont7 content:@"CPCLFont7"];
    [command addTextAtX:50 y:160 rotation:CPCLRotation0 font:CPCLFont24 content:@"CPCLFont24"];
    [command addTextAtX:200 y:160 rotation:CPCLRotation0 font:CPCLFont55 content:@"CPCLFont55"];
    [command addPrint];
    [self printWithData:[command getCommand]];
}

- (IBAction)printQrcodeAction:(id)sender {
    XCPCLCommand *command = [[XCPCLCommand alloc] init];
    [command initLabelWithHeight:600 count:1];
    [command addQRCodeAtX:60 y:120 codeModel:CPCLQRCodeModeEnhance cellWidth:6 content:@"ABC123"];
    [command addPrint];
    [self printWithData:[command getCommand]];
}

- (IBAction)printBarcodeAction:(id)sender {
    XCPCLCommand *command = [[XCPCLCommand alloc] init];
    [command initLabelWithHeight:800 count:1];
    [command barcodeText:5];
    
    [command addTextAtX:50 y:0 content:@"Code 128"];
    [command addBarcodeAtX:50 y:30 type:CPCLBarCode128 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"Code 128"];

    [command addTextAtX:50 y:100 content:@"UPC-A"];
    [command addBarcodeAtX:50 y:130 type:CPCLBarCodeUPCA width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"UPC-A"];

    [command addTextAtX:50 y:200 content:@"UPC-E"];
    [command addBarcodeAtX:50 y:230 type:CPCLBarCodeUPCE width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"UPC-E"];

    [command addTextAtX:50 y:300 content:@"EAN-13"];
    [command addBarcodeAtX:50 y:330 type:CPCLBarCodeEAN13 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"EAN-13"];

    [command addTextAtX:50 y:400 content:@"EAN-8"];
    [command addBarcodeAtX:50 y:430 type:CPCLBarCodeEAN8 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"EAN-8"];

    [command addTextAtX:50 y:500 content:@"Code 39"];
    [command addBarcodeAtX:50 y:530 type:CPCLBarCode39 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"Code 39"];

    [command addTextAtX:50 y:600 content:@"Code 93"];
    [command addBarcodeAtX:50 y:630 type:CPCLBarCode93 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"Code 93"];

    [command addTextAtX:50 y:700 content:@"CODABAR"];
    [command addBarcodeAtX:50 y:730 type:CPCLBarCodeCODABAR width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"CODABAR"];

    [command addPrint];
    [self printWithData:[command getCommand]];
}

- (IBAction)printBarcodeVAction:(id)sender {
    XCPCLCommand *command = [[XCPCLCommand alloc] init];
    [command initLabelWithHeight:600 count:1];
    [command barcodeText:5];
    
//    [command addTextAtX:50 y:0 content:@"Code 128"];
//    [command addBarcodeVAtX:50 y:30 type:CPCLBarCode128 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"Code 128"];
//
//    [command addTextAtX:50 y:100 content:@"UPC-A"];
//    [command addBarcodeVAtX:50 y:130 type:CPCLBarCodeUPCA width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"UPC-A"];
//
//    [command addTextAtX:50 y:200 content:@"UPC-E"];
//    [command addBarcodeVAtX:50 y:230 type:CPCLBarCodeUPCE width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"UPC-E"];
//
//    [command addTextAtX:50 y:300 content:@"EAN-13"];
//    [command addBarcodeVAtX:50 y:330 type:CPCLBarCodeEAN13 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"EAN-13"];
//
//    [command addTextAtX:50 y:400 content:@"EAN-8"];
//    [command addBarcodeVAtX:50 y:430 type:CPCLBarCodeEAN8 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"EAN-8"];
//
//    [command addTextAtX:50 y:500 content:@"Code 39"];
//    [command addBarcodeVAtX:50 y:530 type:CPCLBarCode39 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"Code 39"];
//
//    [command addTextAtX:50 y:600 content:@"Code 93"];
//    [command addBarcodeVAtX:50 y:630 type:CPCLBarCode93 width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"Code 93"];
//
//    [command addTextAtX:50 y:700 content:@"CODABAR"];
//    [command addBarcodeVAtX:50 y:730 type:CPCLBarCodeCODABAR width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"CODABAR"];
    
    [command addTextAtX:50 y:360 content:@"CODABAR"];
    [command addBarcodeVAtX:350 y:550 type:CPCLBarCodeCODABAR width:1 ratio:CPCLBarCodeRatio1 height:50 content:@"A67859B"];

    

    
    [command addPrint];
    [self printWithData:[command getCommand]];
}

- (IBAction)printGeometryAction:(id)sender {
    XCPCLCommand *command = [[XCPCLCommand alloc] init];
    [command initLabelWithHeight:600 count:1];
    [command addBoxAtX:0 y:100 width:100 height:200 thickness:2];
    [command addLineAtX:0 y:150 xend:100 yend:150 width:2];
    [command addInverseLineAtX:0 y:200 xend:100 yend:200 width:2];
    [command addPrint];
    [self printWithData:[command getCommand]];
}

- (IBAction)printImageAction:(id)sender {
    UIImage *image = [UIImage imageNamed:@"image"];
    XCPCLCommand *command = [[XCPCLCommand alloc] init];
    [command initLabelWithHeight:400 count:1];
    [command addGraphicsAtX:0 y:100 image:image];
    [command addPrint];
    [self printWithData:[command getCommand]];
}

- (IBAction)alignAction:(UISegmentedControl *)sender {
    XCPCLCommand *command = [[XCPCLCommand alloc] init];
    [command initLabelWithHeight:240 count:1];
    [command addAlign:self.alignSeg.selectedSegmentIndex end:0];
    [command addTextAtX:0 y:0 rotation:CPCLRotation0 font:CPCLFont2 content:@"TEXT1234"];
    [command addTextAtX:0 y:30 rotation:CPCLRotation0 font:CPCLFont2 content:@"TEXT1234"];
    [command addTextAtX:0 y:60 rotation:CPCLRotation0 font:CPCLFont2 content:@"TEXT1234"];
    [command addTextAtX:0 y:90 rotation:CPCLRotation0 font:CPCLFont2 content:@"TEXT1234"];
    [command addPrint];
    [self printWithData:[command getCommand]];
}

- (IBAction)speedValueChangedAction:(UISlider *)sender {
    self.speedLabel.text = [NSString stringWithFormat:@"Speed:%d",(int)sender.value];
}

- (IBAction)sendSpeedTestAction:(id)sender {
    XCPCLCommand *command = [[XCPCLCommand alloc] init];
    [command initLabelWithHeight:240 count:1];
    [command addSpeed:(int)self.speedSlider.value];
    [command addTextAtX:0 y:0 rotation:CPCLRotation0 font:CPCLFont2 content:@"TEXT1234"];
    [command addPrint];
    [self printWithData:[command getCommand]];
}


- (void)printWithData:(NSData *)dataM {
    if (_connectType == ConnectTypeBluetooth) {
        [_bleManager writeCommandWithData:dataM writeCallBack:^(CBCharacteristic *characteristic, NSError *error) {
            if (error) {
                NSLog(@"error:%@", error);
            } else {
                NSLog(@"write success");
            }
        }];
    } else if (_connectType == ConnectTypeWiFi) {
        [_wifiManager writeCommandWithData:dataM];
    } else {
        [self.view makeToast:@"printer no connect" duration:1.f position:CSToastPositionCenter];
    }
}

@end
