//
//  CustomizationVC.m
//  PrinterDemo
//
//  Created by Apple Mac mini intel on 2024/5/5.
//

#import "CustomizationVC.h"
#import "TSPLCompressionVC.h"
#import "POSCompressionVC.h"

@interface CustomizationVC ()<UITableViewDelegate, UITableViewDataSource>
@property (weak, nonatomic) IBOutlet UITableView *tableView;
@property (nonatomic, strong) NSArray<NSDictionary<NSString *, NSString *> *> *sceneData;
@end

@implementation CustomizationVC

- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = @"Scene Sets";
    [self setupSceneData];
}

- (void)setupSceneData {
    self.sceneData = @[
        @{@"title": @"TSPL Pic Print (BLE)", @"subtext": @"Check if the printer supports compression"},
        @{@"title": @"POS Pic print (BLE)", @"subtext": @"Check if the printer supports compression"},
    ];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.sceneData.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellId = @"printerCell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellId];
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellId];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }

    NSInteger sectionOffset = 0;
    for (int i = 0; i < indexPath.section; i++) {
        sectionOffset += [self tableView:tableView numberOfRowsInSection:i];
    }
    NSInteger index = sectionOffset + indexPath.row;
    cell.textLabel.text = self.sceneData[index][@"title"];
    cell.detailTextLabel.text = self.sceneData[index][@"subtext"];
    cell.detailTextLabel.textColor = [UIColor grayColor];
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 100;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (indexPath.row == 0) {
        UIStoryboard *story = [UIStoryboard storyboardWithName:@"Main" bundle:[NSBundle mainBundle]];
        UIViewController *vc = [story instantiateViewControllerWithIdentifier:@"TSPLCompression"];
        [self.navigationController pushViewController:vc animated:YES];
    }
    
    if (indexPath.row == 1) {
        UIStoryboard *story = [UIStoryboard storyboardWithName:@"Main" bundle:[NSBundle mainBundle]];
        UIViewController *vc = [story instantiateViewControllerWithIdentifier:@"POSCompression"];
        [self.navigationController pushViewController:vc animated:YES];
    }
    
}


@end
